<?php

namespace App\Contract;

use App\Service\PricingStrategy;
use App\Service\TrivialPricingStrategy;

class ProductEntry
{
    public function __construct(
        private string $productId,
        private int $quantity,
        private float $price,
        private float $weight,
    ) {
    }

    public function getProductId(): string
    {
        return $this->productId;
    }

    public function setProductId(string $productId): void
    {
        $this->productId = $productId;
    }

    public function getQuantity(): int
    {
        return $this->quantity;
    }

    public function setQuantity(int $quantity): void
    {
        $this->quantity = $quantity;
    }

    public function getPrice(): float
    {
        return $this->price;
    }

    public function getPriceAsInt(): int
    {
        return round($this->getPrice() * 100);
    }

    public function setPrice(float $price): void
    {
        $this->price = $price;
    }

    public function getWeight(): float
    {
        return $this->weight;
    }

    public function setWeight(float $weight): void
    {
        $this->weight = $weight;
    }

    public function getTotalWeight(): float
    {
        return $this->getWeight() * $this->getQuantity();
    }

    public function getTotalPrice(PricingStrategy $strategy): float
    {
        return $strategy->calculateTotalPriceOfProductEntry($this);
    }
}
