<?php

namespace App\Exception;

use App\Contract\Order;
use Symfony\Component\Validator\ConstraintViolationListInterface;

class OrderInvalidException extends \LogicException
{
    private ConstraintViolationListInterface $violations;

    public function getViolations(): ConstraintViolationListInterface
    {
        return $this->violations;
    }

    public static function createFromViolations(Order $order, ConstraintViolationListInterface $violations): self
    {
        $exception = new self(sprintf(
            'Order "%s" is not valid, contains %d errors.',
            $order->getOrderId()->toRfc4122(),
            $violations->count()
        ));
        $exception->violations = $violations;

        return $exception;
    }
}
