<?php

namespace App\Service;

use App\Contract\Order;
use App\Contract\ProductEntry;

class TrivialPricingStrategy implements PricingStrategy
{
    public function calculateTotalPriceOfProductEntry(ProductEntry $product): int
    {
        $priceInBaseUnit = $product->getPriceAsInt();

        return $priceInBaseUnit * $product->getQuantity();
    }

    public function calculateTotalPriceOfOrder(Order $order): int
    {
        return array_sum(array_map($this->calculateTotalPriceOfProductEntry(...), $order->getProducts()));
    }
}
